您的位置:首页 > 理论基础 > 计算机网络

2017 ACM-ICPC 亚洲区(南宁赛区)网络赛 L. The Heaviest Non-decreasing Subsequence Problem

2017-09-24 21:09 453 查看
Let SS be
a sequence of integers s_{1}s​1​​, s_{2}s​2​​, ......, s_{n}s​n​​ Each
integer is is associated with a weight by the following rules:
(1) If is is negative, then its weight is 00.

(2) If is is greater than or equal to 1000010000,
then its weight is 55.
Furthermore, the real integer value of s_{i}s​i​​ is s_{i}-10000s​i​​−10000 .
For example, if s_{i}s​i​​ is 1010110101,
then is is reset to 101101 and
its weight is 55.

(3) Otherwise, its weight is 11.

A non-decreasing subsequence of SS is
a subsequence s_{i1}s​i1​​, s_{i2}s​i2​​, ......, s_{ik}s​ik​​,
with i_{1}<i_{2}\
...\ <i_{k}i​1​​<i​2​​ ... <i​k​​,
such that, for all 1
\leq j<k1≤j<k,
we have s_{ij}<s_{ij+1}s​ij​​<s​ij+1​​.

A heaviest non-decreasing subsequence of SS is
a non-decreasing subsequence with the maximum sum of weights.

Write a program that reads a sequence of integers, and outputs the weight of its

heaviest non-decreasing subsequence. For example, given the following sequence:

8080 7575 7373 9393 7373 7373 1010110101 9797 -1−1 -1−1 114114 -1−1 1011310113 118118

The heaviest non-decreasing subsequence of the sequence is <73,
73, 73, 101, 113, 118><73,73,73,101,113,118> with
the total weight being 1+1+1+5+5+1
= 141+1+1+5+5+1=14.
Therefore, your program should output 1414 in
this example.

We guarantee that the length of the sequence does not exceed 2*10^{5}2∗10​5​​


Input Format

A list of integers separated by blanks:s_{1}s​1​​, s_{2}s​2​​,......,s_{n}s​n​​


Output Format

A positive integer that is the weight of the heaviest non-decreasing subsequence.

样例输入

80 75 73 93 73 73 10101 97 -1 -1 114 -1 10113 118


样例输出

14



题目来源

2017
ACM-ICPC 亚洲区(南宁赛区)网络赛

分析:人生的第一个树状数组优化dp题目,尴尬的是队友会dp,我会树状数组,很遗憾,没做出来。

这里介绍两种思路。

思路见代码 :

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<algorithm>
using namespace std;

int tree[300005];
struct Node {
int a[300005];
int val[300005];
}data;
int dp[300005];
void add(int x,int num)
{
for(int i=x;i<=300005;i+=i&-i)
if(num>tree[i])
tree[i]=num;
}
int read(int x)
{
int num=0;
for(int i=x;i>0;i-=i&-i)
if(num<tree[i])
num=tree[i];
return num;
}
int main()
{
int n=1;
while(~scanf("%d",&data.a
))
{
if(data.a
<0) //负数可以不存
continue;
else if(data.a
>=10000)
{
data.a
-=10000; //大于10000的数,real值是原数减10000
data.val
=5;
}
else
data.val
=1;
n++;
}
dp[1]=data.val[1];
add(data.a[1],dp[1]);
int ans=-1;
for(int i=2;i<n;i++)
{//为什么说是树状数组优化dp,因为这里本来是又一层循环,用来查找在满足data.a[j]<=data.a[i]的情况下,
//寻找最大的dp[j]; 所以咱们以 data.a[i]为区间坐标,求区间最值,从0~data.a[i]中找到的最大的dp[j],
//一定满足 data.a[j]<=data.a[i]
int j=read(data.a[i]);
dp[i]=max(dp[i],j+data.val[i]);
add(data.a[i],dp[i]);
ans=max(ans,dp[i]);
}
printf("%d\n",ans);
return 0;
}

第二种:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<algorithm>
using namespace std;

int a[1000005];
int dp[1000005];
int main()
{
int n;
n=1;
while(~scanf("%d",&a
))
{//既然只有val==1,5的时候有用,而且求的是不下降的heavies序列。那么不妨将这些val=5的
//拆分成5个val=1的,然后直接求解最大不下降子序列。
if(a
<0)
continue;
else if(a
>=10000)
{
a
-=10000;
int tem=a
;
n++;
for(int i=0;i<4;i++)
a[n++]=tem;
}
else
n++;
}
int len=1;
memset(dp,0,sizeof(dp));
dp[1]=a[1];
for(int i=2;i<n;i++)
{
if(a[i]>=dp[len])
dp[++len]=a[i];
else
{
int add = lower_bound(dp+1,dp+len+1,a[i]) - dp;
while(dp[add]<=a[i])
add++;
dp[add] = a[i];
}
}
if(n==1 && a
<0)//注意边界情况处理
printf("0\n");
else
printf("%d\n",len);

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
相关文章推荐